#include<iostream>

using namespace std;

long long a[200000];

int main()
{
	long long n, k, rez=0;
	cin>>n>>k;
	for(long long i=0; i<n; i++)
	{
		cin>>a[i];
	}
	if(k==0)
	{
		for(long long i=0; i<n; i++)
		{
			rez+=a[i]%1000000007;
			rez=rez%1000000007;
		}
	}
	else if(k==1)
	{
		for(long long i=n; i>0; i--)
		{
			rez+=(i*(n-i+1))*a[i-1]%1000000007;
			rez=rez%1000000007;
		}
	}
	else
	{
		rez=1;
	}
	cout<<rez;
	return 0;
}